package com.sky.controller.admin;

import com.sky.result.Result;
import com.sky.utils.AliOssUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.UUID;

/*
* 通用接口
*hello图床：  715|WGoDylnmBWl4YX9VNNBqDUxWe0349SBVs3RLNaXw
* */
@RestController
@RequestMapping("/admin/common")
@Api(tags = "通用接口")
@Slf4j
public class CommonController {

    @Autowired
    private AliOssUtil aliOssUtil;

    @PostMapping("/upload")
    @ApiOperation("文件上传")
    public Result<String> upload(MultipartFile file){
        log.info("文件开始上传：{}",file);
//        上传到阿里云服务器空间
        try {
//            原始文件名
            String originalFilename = file.getOriginalFilename();
//            截取后缀
            String extension = originalFilename.substring(originalFilename.lastIndexOf("."));
//            重命名
            String objectName = UUID.randomUUID().toString() + extension;
            String filePath =  aliOssUtil.upload(file.getBytes(), objectName);
            return Result.success(filePath);
        } catch (IOException e) {
            log.error("文件上传失败",e );
        }
        return null;
    }
}
